/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.baselibs;

import cdac.medinfo.sdk.hl7282.baselibs.segmentfactory.DataElementFactory;
import cdac.medinfo.sdk.hl7282.commoninterface.IDataType;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidComponentTypeException;
import cdac.medinfo.sdk.hl7282.utils.EnumDataType;
import cdac.medinfo.sdk.hl7282.utils.IDataTypeMap;

/**
 * SN - Structured numeric<p>
 * This data type is used to unambiguously express numeric clinical 
 * results along with qualifications.
 * <p>Represents an HL7 SN data type. 
 * This data type has the following attributes:</p><p>
 *  1. Comparator (ST)<b>Optional</b><br>
 *  2. Num1 (NM)<b>Optional</b><br>
 *  3. Separator/Suffix (ST)<b>Optional</b><br>
 *  4. Num2 (NM)<b>Optional</b><br><p>
 * This class provides accessors & mutators for the elements mentioned above.
 * This class override the equal method, to check whether some other object is "equal to" this one.
 * 
 * <p>User can also create Data Type through {@link DataElementFactory} 
 */
public class SN extends CompositeDataType    
{
	


	/**
	 * Default Constructor for SN
	 */
	public SN()
	{
		super(EnumDataType.HL7_DT_SN);
		 
	}

	/**
	 * Constructor  for CQ class which takes four arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */ 
	public SN(int iMinLength, int iMaxLength, String strCLength,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_SN);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}


	/**
	 * Constructor for SN class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public SN(int iMinLength, int iMaxLength, String strCLength,int iTableNo,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_SN);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iTableNo = iTableNo;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());		
		}
	}
	/**
	 * Constructor for SN class which takes two arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public SN(int iComponentType,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_SN);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for SN class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public SN(int iComponentType,int iMinLength, int iMaxLength, String strCLength,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_SN);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for SN class which takes six arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public SN(int iComponentType,int iMinLength, int iMaxLength, String strCLength,int ITableNo,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_SN);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iTableNo = ITableNo;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}

	/**
	 *Sets the Comparator.
	 *@param strComparator  Defined as greater than, less than, greater than or equal, 
	 *						less than or equal, equal, and not equal, respectively ( ">" or "<" or ">=" or "<=" or "=" or "<>" ).
	 */
	public void setComparator(String strComparator)
	{
		if(strComparator!=null)
			setComponentType(1, strComparator);
		else
			setComparator((ST)null);
	}


	/**
	 *Sets the Comparator.
	 *@param objST Defined as greater than, less than, greater than or equal, 
	 *						less than or equal, equal, and not equal, respectively ( ">" or "<" or ">=" or "<=" or "=" or "<>" ).
	 */
	public void setComparator(ST objST)
	{
		setComponentType(1,objST);
	}

	/**
	 *Sets the Num1.
	 *@param strNum1  Specifies a number. 
	 */
	public void setNum1(String strNum1)
	{
		if(strNum1!=null)
			setComponentType(2, strNum1);
		else
			setNum1((NM)null);
	}

	/**
	 *Sets the Num1.
	 *@param objNM Specifies a number. 
	 */
	public void setNum1(NM objNM)
	{
		setComponentType(2,objNM);
	}

	/**
	 *Sets the SeparatorSuffix.
	 *@param strSeparatorSuffix Specifies separator suffix such as ( "-" or "+" or "/" or "." or ":" ). 
	 */
	public void setSeparatorSuffix(String strSeparatorSuffix)
	{
		if(strSeparatorSuffix!=null)
			setComponentType(3, strSeparatorSuffix);
		else
			setSeparatorSuffix((ST)null);
	}

	/**
	 *Sets the SeparatorSuffix.
	 *@param objST Specifies separator suffix such as ( "-" or "+" or "/" or "." or ":" ).
	 */
	public void setSeparatorSuffix(ST objST)
	{
		setComponentType(3,objST);
	}

	/**
	 *Sets the Num2.
	 *@param strNum2 Specifies a number or null depending on the measurement. 
	 */
	public void setNum2(String strNum2)
	{
		if(strNum2!=null)
			setComponentType(4, strNum2);
		else
			setNum2((NM)null);
	}

	/**
	 *Sets the Num2.
	 *@param objNM Specifies a number or null depending on the measurement. 
	 */
	public void setNum2(NM objNM)
	{
		setComponentType(4,objNM);
	}

	/**
	 * Returns Comparator
	 * @return ST - Data Type
	 */
	public ST getComparator()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(1);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ST)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Num1
	 * @return NM - Data Type
	 */
	public NM getNum1()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(2);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (NM)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Separator/Suffix
	 * @return ST - Data Type
	 */
	public ST getSeparatorSuffix()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(3);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ST)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Num2
	 * @return NM - Data Type
	 */
	public NM getNum2()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(4);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (NM)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * This method checks the equality of Object.
	 * @param objObject object of Object class.
	 * @return boolean - shows success or failure of the comparison.
	 */
	public boolean equals(Object objObject)
	{
		if((objObject == null ) || (!(objObject instanceof SN)))
			return false;

		if(this.getComparator() == null)
		{
			if(((SN)objObject).getComparator() != null)
				return false;
		}
		else if(false == (this.getComparator().equals(((SN)objObject).getComparator())))
			return false;

		if(this.getNum1() == null)
		{
			if(((SN)objObject).getNum1() != null)
				return false;
		}
		else if(false == (this.getNum1().equals(((SN)objObject).getNum1())))
			return false;

		if(this.getSeparatorSuffix() == null)
		{
			if(((SN)objObject).getSeparatorSuffix() != null)
				return false;
		}
		else if(false == (this.getSeparatorSuffix().equals(((SN)objObject).getSeparatorSuffix())))
			return false;

		if(this.getNum2() == null)
		{
			if(((SN)objObject).getNum2() != null)
				return false;
		}
		else if(false == (this.getNum2().equals(((SN)objObject).getNum2())))
			return false;

		return true;
	}
}
